#include <os.h>
#include "menu.h"
#include "output.h"

#define MENU_BACKGROUND_COLOR ( has_colors?0b1111111111111111:0xC )
#define MENU_SHADOW_COLOR (has_colors?0b0111101111101111:0x5 )
#define MENU_SELECTION_COLOR (has_colors?0b011101111111111:0x0)

#define MAX_ENTRY_NUM 32
#define MAX_ENTRY_LEN 64

//void dispMenuTile(uint8_t* scrbuf, int x, int y, int w, int h, int color, char* option){
//    dispRect(scrbuf, x, y, w, h, 0x0);
//    filledRect(scrbuf, x+1, y+1, w-2, h-2, color);
//    dispString(scrbuf, x+3, y+3, option);
//}

int dispMenu(uint8_t* scrbuf, int x, int y, const char* menu, int selected){//returns number of items in menu //Warning: disps only 32 entries  63 chars max
    char entrylist[MAX_ENTRY_NUM][MAX_ENTRY_LEN];
    int h = 0;
    int w = 0;
    int linelen = 0;
    int i = 0;
    const char* p = menu;
    p--;
    do{//build array of the entries' names, determine width and heighth needed
		p++;
        if(*p == '\n' || *p == '\0'){
			strncpy(entrylist[i], p-linelen, min(linelen, MAX_ENTRY_LEN-1));
			entrylist[i][min(linelen, MAX_ENTRY_LEN-1)] = '\0';
			i++;
			h++;
			w = max(linelen, w);
            linelen = 0;
        }
        else
            linelen++;
    }while(*p != '\0' && i < MAX_ENTRY_NUM);
    h = h*(CHAR_HEIGHT + 4);
    w = 2 + (w + 1)*CHAR_WIDTH;

    dispRect(scrbuf, x, y, w+2, h+2, 0);
    filledRect(scrbuf, x+1, y+1, w, h, MENU_BACKGROUND_COLOR);
    dispHorizLine(scrbuf, x+1, y+h+2, w+2, MENU_SHADOW_COLOR);
    dispHorizLine(scrbuf, x+2, y+h+3, w+2, MENU_SHADOW_COLOR);
    dispVertLine(scrbuf, x+w+2, y+1, h+2, MENU_SHADOW_COLOR);
    dispVertLine(scrbuf, x+w+3, y+2, h+2, MENU_SHADOW_COLOR);

	y += 3;
	int j;
	for(j=0; j<i; j++, y += CHAR_HEIGHT + 4){
		if(j == selected - 1){
			filledRect(scrbuf, x+1, y-2, w, CHAR_HEIGHT+4, MENU_SELECTION_COLOR);
            dispStringColor(scrbuf, x+3, y, entrylist[j], has_colors?0xFFFF:0xF, MENU_SELECTION_COLOR);
		}
		else
			dispString(scrbuf, x+3, y, entrylist[j]);
	}

    return i;
}
