#include <os.h>
#include "utils.h"
#include "navigation.h"

inline void insert(char* buffer, int position, char ins){
    memmove(buffer + position + 1, buffer + position, strlen(buffer) - position + 1);
    *(buffer + position) = ins;
}

inline void insertstr(char* buffer, int position, char* ins){
    memmove(buffer + position + strlen(ins), buffer + position, strlen(buffer) - position + 1);//move everything including null char!
    memcpy(buffer + position, ins, strlen(ins));
}

inline char delchar(char* buffer, int position){
    char deletedchar = buffer[position-1];
    if(position != strlen(buffer))
        memmove(buffer + position - 1, buffer + position, strlen(buffer) - position + 1);
    else
        *(buffer + position - 1) = '\0';
    return deletedchar;
}

inline void delselection(char* buffer, int startoffset, int endoffset){
    if(buffer[endoffset] != '\0')
        memmove(buffer+startoffset, buffer+endoffset, strlen(buffer) - endoffset + 1);//move everything after selection (including null character)
    else
        buffer[startoffset] = '\0';
}


char* getline(char* textbuffer, int pos, int cursorscreenrow){//returns pointer to first character of screen where position is in row=cursorscreenrow on screen
    while(cursorscreenrow--)
        pos = prevline(textbuffer, pos);
    pos = currentline(textbuffer, pos);
    return textbuffer + pos;
}

char* getline_nosoftbreak(char* textbuffer, int pos, int cursorscreenrow){
    while(cursorscreenrow--)
        pos = prevline_nosoftbreak(textbuffer, pos);
    pos = currentline_nosoftbreak(textbuffer, pos);
    return textbuffer + pos;
}


void update_selection(int oldpos, int newpos, int* selectionstart, int* selectionend){
    if(!isKeyPressed(KEY_NSPIRE_SHIFT)){
        *selectionstart = newpos;
        *selectionend = newpos;
    }
    else{
        if(oldpos == *selectionstart){
            if(newpos <= *selectionend)
                *selectionstart = newpos;
            else{
                *selectionstart = *selectionend;
                *selectionend = newpos;
            }
        }
        else{//if oldpos == *selectionend
            if(newpos >= *selectionstart)
                *selectionend = newpos;
            else{
                *selectionend = *selectionstart;
                *selectionstart = newpos;
            }
        }
    }
}

char* strrstr(char* s1, char* s2){
    if(s2[0] == '\0')
        return s1;
    char* p = strstr(s1, s2);
    if(p == NULL)
        return NULL;
    while(strstr(p+1, s2) != NULL)
        p = strstr(p+1, s2);
    return p;
}
